%{
open Types
%}
  
%token <int> INT
(* %token <string> STRING  *)
%token <string> PROP_VAR
%token SUCC  FORCES WORLD COUNT_W COUNT_PW COUNT_ATSETS ROOT
%token LPAREN RPAREN COMMA
%token SPACE EOL 



%start <Types.value list > main

%%

main:
  | ls = value_list  EOL  { ls }
  


    
value_list:
|    ls = separated_nonempty_list(SPACE,value)    { ls } ;


value:    
|  SUCC LPAREN w1 = word COMMA w2 = word RPAREN
    { Succ(w1,w2) }
|  FORCES LPAREN w = word COMMA str = PROP_VAR RPAREN
    { Forces(w, P str) } 
| COUNT_W LPAREN n = INT RPAREN
    {CountW(n)  }
| COUNT_PW LPAREN n = INT RPAREN
    {CountPW(n)  }
| COUNT_ATSETS LPAREN n = INT RPAREN
    {CountAtSets(n)  }

| ROOT LPAREN w = word RPAREN
    { Root w }
    
word:
| WORLD LPAREN n = INT RPAREN    
    { W(n) }
    

